/* (c) Terasense Group, Inc., 2015

The simplest programm that read data from a Tera-xxxx device.

*/


#include "libteraview.h"

#include <stdlib.h>

int main(int argc, char* argv[])
{	
	TS_RES res = TS_OK;
	TS_DATA buf;
	
// Initialize the device

	res = tsInit();
	if (res != TS_OK) {
		printf("Device initialization failed, code %d", res);
		return res;
	}
	else 
		printf("Device initialized.\nReading %d pixels (%dx%d).\n", dataLength, sizeX, sizeY);

// Allocate memory for the data buffer. Notice that dataLength variable is not set prior initialization.
	buf = (TS_DATA) malloc(dataLength*sizeof(TS_ELEMENT));

// Start data aquisition
	res = tsStart();
	if (res != TS_OK) {
			printf("Error starting acquisition, code %d\n", res);
	}
// Read data
	res = tsRead(buf);
	if (res != TS_OK) {
		printf("Error reading data, code %d\n", res);
	}
	else{
// Do something with the data.
		for (int y = 0; y < sizeY; y++){
			for (int x = 0; x < sizeX; x++){
				printf("%4d ", buf[x*sizeY + y]);
			}
			printf("\n");
		}
	}
// Stop data aquisition.
	res = tsStop();

// Close the device.
	res = tsClose();

//Release memory
	free(buf);


	printf("Press ENTER to continue.");
	getchar();

	

	return res;

}

